=== debian/changelog ===
telegram-desktop (4.10.3+ds-1revyos1) unstable; urgency=medium

  * Use gcc-13

 -- Han Gao <gaohan@iscas.ac.cn>  Thu, 19 Oct 2023 22:38:22 +0800

telegram-desktop (4.10.3+ds-1) unstable; urgency=medium

  * New upstream release.
  * Resolve conflicts in patches.
  * New recommended dependency, libwebkitgtk-6.0-4 package.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 03 Oct 2023 20:06:15 +0300

telegram-desktop (4.9.7+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update patches.
    - Removed taken from upstream:
      + 1001-Improve-small-blocklist-layout-fix-heightMin.patch
    - Newly added:
      + 1001-Revert-Fix-QGuiApplication-desktopFileName-usage.patch (Closes:
        #1051032)
      + 1002-Revert-Workaround-cmake-bug-25222.patch
      + 2016-Fix-build-against-Qt5-in-Linux.patch
      + 2017-Log-system-info.patch
      + 2018-Prefer-Xwayland.patch
      + 2019-Unblock-system-window-frame.patch (Closes: #1050929)
    - Rewritten:
      + 2001-Hide-irrelevant-warnings.patch
    - Refreshed with no change:
      + 2007-Packed-resources.patch
  * Rebuilt against libmsgsl-dev (>= 4.0.0-3) (Closes: #1050903)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 13 Sep 2023 22:15:43 +0300

telegram-desktop (4.9.3+ds-1) unstable; urgency=medium

  * New upstream release.
  * Exclude cppgir, Implib.so, and Wayland sources, and also libtgvoip's CMake
    scripts from the repacked tarball.
  * Resolve conflicts in patches:
    + Remove all previous patches taken from upstream.
    + Remove all existing backporting patches.
    + Remove conflicting 2009-Revert-network-monitor.patch, no longer needed.
    + Add new 2015-System-wide-cppgir.patch.
    + Refresh other patches with fuzzy chunks.
    + Import 1001-Improve-small-blocklist-layout-fix-heightMin.patch from
      upstream Git.
  * New build dependencies, cppgir and GObject Introspection tools.
  * Disable Wayland integration, it needs too large a patch to work with Qt5.
  * Mention new little-endian architecture, LoongArch.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 29 Aug 2023 21:45:49 +0300
